package com.maroontress.madangler.client.config;

import com.google.gwt.core.client.GWT;
import com.google.gwt.http.client.URL;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
   ΥѥͥǤ
*/
public class GenericPanel extends DockPanel {

    /** ץȤ */
    private ConfigTextPanel description;

    /** ӥURL */
    private HTML notificationURL;

    /**
       Υѥͥޤ

       @param model ץΥǥ
    */
    public GenericPanel(final ConfigModel model) {
	model.addChangedListener(new ChangedListener() {
	    public void propertyChanged(final ConfigModel model) {
		description.setText(model.getProperty("description"));
	    }
	});

	description = new ConfigTextPanel("Description", 64,
					  model, "description");
	notificationURL = new HTML();

	VerticalPanel vp = new VerticalPanel();
	vp.add(description);
	vp.add(new HTML("&nbsp;"));
	vp.add(new HTML("Notificaiton URL"));
	vp.add(notificationURL);
	add(vp, DockPanel.NORTH);
	add(new HTML("&nbsp;"), DockPanel.CENTER);
    }

    /**
       ץIDꤷޤ

       @param id ץID
    */
    public void setProjectId(final String id) {
	notificationURL.setHTML(GWT.getHostPageBaseURL() + "shell.cgi"
				+ "?projectId=" + URL.encodeComponent(id)
				+ "&amp;" + "revision=<i>REVISION</i>"
				+ "&amp;" + "author=<i>AUTHOR</i>");
    }
}
