#ifndef Environment_H
#define Environment_H

#define Environment_copyXML(e, name) Environment_setXML(e, #name, name)

struct com_maroontress_libcgi_db_Box;
struct Environment;

struct Environment * Environment_create(void);
void Environment_free(struct Environment *);
int Environment_execute(struct Environment *, const char *const *);
int Environment_setXML(struct Environment *, const char *, const char *);
int Environment_setRaw(struct Environment *, const char *, const char *);
int Environment_copyXMLByBox(struct Environment *, const char *,
			     struct com_maroontress_libcgi_db_Box *);
int Environment_setXMLByBox(struct Environment *, const char *,
			    struct com_maroontress_libcgi_db_Box *,
			    const char *);
int Environment_setRawByBox(struct Environment *, const char *,
			    struct com_maroontress_libcgi_db_Box *,
			    const char *);
#endif /* !Environment_H */
