#ifndef Project_H
#define Project_H

#include <sys/types.h>

struct Project;
struct com_maroontress_libcgi_db_Tree;
struct com_maroontress_libcgi_db_Tree_Mode;

struct Project * Project_create(const char *projectID);
void Project_free(struct Project *pj);
char * Project_getBasePath(struct Project *pj);
char * Project_getDBPath(struct Project *bl);

struct com_maroontress_libcgi_db_Tree * Project_createTree(
    struct Project *pj,
    const struct com_maroontress_libcgi_db_Tree_Mode *mode);
int Project_removeDir(struct Project *pj);
int Project_makeDir(struct Project *pj);

#endif
